
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#ifndef HDR_edtConfig
#define HDR_edtConfig

#include <string>

#include <tlString.h>
#include <dbPoint.h>

#include "edtSnap.h"

namespace edt
{

/** 
 *  @brief Declaration of the configuration names
 */
extern std::string cfg_edit_grid;
extern std::string cfg_edit_move_angle_mode;
extern std::string cfg_edit_connect_angle_mode;
extern std::string cfg_edit_text_string;
extern std::string cfg_edit_text_size;
extern std::string cfg_edit_path_width;
extern std::string cfg_edit_path_ext_type;
extern std::string cfg_edit_path_ext_var_begin;
extern std::string cfg_edit_path_ext_var_end;
extern std::string cfg_edit_global_grid;
extern std::string cfg_edit_inst_cell_name;
extern std::string cfg_edit_inst_angle;
extern std::string cfg_edit_inst_mirror;
extern std::string cfg_edit_inst_scale;
extern std::string cfg_edit_inst_array;
extern std::string cfg_edit_inst_rows;
extern std::string cfg_edit_inst_row_x;
extern std::string cfg_edit_inst_row_y;
extern std::string cfg_edit_inst_columns;
extern std::string cfg_edit_inst_column_x;
extern std::string cfg_edit_inst_column_y;
extern std::string cfg_edit_top_level_selection;

// ------------------------------------------------------------
//  Helper functions to get and set the configuration

enum path_ext_type { Flush = 0, Square, Variable, Round, NumPEModes };

struct ACConverter 
{
  std::string to_string (const lay::angle_constraint_type &m);
  void from_string (const std::string &s, lay::angle_constraint_type &m);
};

struct PathExtConverter 
{
  std::string to_string (const edt::path_ext_type &m);
  void from_string (const std::string &s, edt::path_ext_type &m);
};

struct EditGridConverter
{
  std::string to_string (const db::DPoint &eg);
  void from_string (const std::string &s, db::DPoint &eg);
  void from_string_picky (const std::string &s, db::DPoint &eg);
};

}

#endif


