
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#include <QtGui/QApplication>
#include <QtGui/QFont>
#include <QtGui/QBitmap>
#include <QtGui/QPainter>
#include <QtGui/QFontDialog>

#include <stdio.h>

int 
main (int argc, char *argv [])
{
  QApplication app (argc, argv);

  //  select font
  bool ok = true;
  QFont f = QFontDialog::getFont (&ok, QFont ("B&H LucidaTypewriter", 12));
  if (!ok) {
    return 1;
  }

  QFontMetrics fm (f);

  printf ("\n// generated by fontgen\n// Font %s\n// DO NOT EDIT !\n", f.toString ().ascii ());

  printf ("\nnamespace lay {\n\nconst unsigned int ff_height = %d;\nconst unsigned int ff_line_height = %d;\nconst unsigned int ff_width = %d;\n",
    fm.height (), fm.lineSpacing (), fm.width ('a'));

  printf ("const unsigned char ff_first_char = ' ';\n\nuint32_t ff_data [][%d] = {\n",
    fm.height ());

  for (int c = ' '; c < 256; ++c) {

    QBitmap b (fm.width ('a'), fm.height (), true);
    QPainter p (&b);
    p.setFont (f);

    char t[2];
    t[0] = c;
    t[1] = 0;
    p.drawText (0, fm.ascent (), t);

    QImage img (b.convertToImage ());

    printf ("  // %d\n  { ", c);
    for (int i = 0; i < fm.height (); ++i) {
      if (i > 0) {
        printf (", ");
      }
      printf ("0x%x", *(int *)img.scanLine (i) & ((1 << fm.width ('a')) - 1));
    }
    printf (" },\n");

  }

  printf ("};\n\n} // namespace lay\n");

  return 0;
}


