
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



#ifndef HDR_layConfig
#define HDR_layConfig

#include <string>

namespace lay
{

/** 
 *  @brief Declaration of the configuration names
 */
extern const std::string cfg_abs_units;
extern const std::string cfg_apply_text_trans;
extern const std::string cfg_array_border_instances;
extern const std::string cfg_background_color;                                 
extern const std::string cfg_cell_box_color;
extern const std::string cfg_cell_box_text_font;
extern const std::string cfg_cell_box_text_transform;
extern const std::string cfg_cell_box_visible;
extern const std::string cfg_clear_ruler_new_cell;
extern const std::string cfg_color_palette;
extern const std::string cfg_ctx_color;                                        
extern const std::string cfg_ctx_dimming;                                      
extern const std::string cfg_current_ruler_template;                                     
extern const std::string cfg_dbu_units;
extern const std::string cfg_default_dbu;
extern const std::string cfg_default_grids;
extern const std::string cfg_default_lyp_file;
extern const std::string cfg_default_text_size;
extern const std::string cfg_drop_small_cells;
extern const std::string cfg_drop_small_cells_cond;
extern const std::string cfg_drop_small_cells_value;
extern const std::string cfg_edit_mode;
extern const std::string cfg_fit_new_cell;
extern const std::string cfg_full_hier_new_cell;
extern const std::string cfg_grid;
extern const std::string cfg_grid_color;                                                
extern const std::string cfg_grid_micron;                                               
extern const std::string cfg_grid_style0;                                               
extern const std::string cfg_grid_style1;                                               
extern const std::string cfg_grid_style2;                                               
extern const std::string cfg_grid_visible;                                              
extern const std::string cfg_key_bindings;
extern const std::string cfg_min_inst_label_size;
extern const std::string cfg_mouse_wheel_mode;
extern const std::string cfg_mru;
extern const std::string cfg_reader_enable_properties;
extern const std::string cfg_reader_enable_text_objects;
extern const std::string cfg_sel_color;                                        
extern const std::string cfg_sel_halo;
extern const std::string cfg_sel_line_width;                                   
extern const std::string cfg_sel_transient_mode;
extern const std::string cfg_sel_vertex_size;
extern const std::string cfg_show_hierarchy_panel;                                  
extern const std::string cfg_show_layer_panel;                                      
extern const std::string cfg_show_properties;
extern const std::string cfg_show_toolbar;
extern const std::string cfg_stipple_palette;
extern const std::string cfg_synchronized_views;
extern const std::string cfg_text_color;
extern const std::string cfg_text_font;
extern const std::string cfg_text_lazy_rendering;
extern const std::string cfg_text_visible;
extern const std::string cfg_hide_empty_layers;
extern const std::string cfg_test_shapes_in_view;

}

#endif

