
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2007 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



#include "layDrawing.h"

namespace lay
{

Drawing::Drawing (unsigned int num_planes, Drawings *drawings)
  : m_num_planes (num_planes), mp_drawings (drawings)
{
  drawings->insert (this, false /*not owner*/);
}

Drawing::~Drawing ()
{
  // .. nothing yet ..
}

void 
Drawing::set_view_ops (const std::vector <lay::ViewOp> &view_ops)
{
  if (m_view_ops != view_ops) {
    m_view_ops = view_ops;
    mp_drawings->update_drawings ();
  }
}

}

